package mondrian.venki.prototypes;

import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.Hashtable;
import java.util.List;
import java.util.Vector;

import mondrian.olap.CacheControl;
import mondrian.olap.Cube;
import mondrian.olap.Id;
import mondrian.olap.Member;
import mondrian.olap.SchemaReader;
import mondrian.olap.CacheControl.MemberSet;
import mondrian.rolap.RolapCube;
import mondrian.rolap.RolapSchema;

import org.olap4j.CellSet;
import org.olap4j.OlapConnection;
import org.olap4j.OlapException;
import org.olap4j.OlapStatement;
import org.olap4j.layout.*;

public class DimCacheTester {
	
	private OlapConnection oc = null;
	private Connection connection = null;
	private mondrian.olap.Connection mondrianConnection = null;
	private java.sql.Connection sqlConnection = null;
		
	private static String CATALOG_FILE="C:\\mondriansetup\\logs\\testCube.xml;";
	private static String CONNECT_STRING = "jdbc:mondrian:Jdbc=jdbc:sybase:Tds:localhost:2638;JdbcUser=asapp;JdbcPassword=asapp;JdbcDrivers=com.sybase.jdbc3.jdbc.SybDriver; Catalog=" + CATALOG_FILE ;
	private String jdbcUrl="jdbc:sybase:Tds:localhost:2638";

 public DimCacheTester() {
	// TODO Auto-generated constructor stub
	 try {
		Class.forName("mondrian.olap4j.MondrianOlap4jDriver");
		 connection = DriverManager.getConnection(CONNECT_STRING);
		 oc = connection.unwrap(OlapConnection.class);
		 mondrianConnection = connection.unwrap(mondrian.olap.Connection.class);
		 Class.forName("com.sybase.jdbc3.jdbc.SybDriver");
		 sqlConnection =
		        DriverManager.getConnection(jdbcUrl, "asapp", "asapp");
	} catch (ClassNotFoundException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (SQLException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}



}
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception{

		try {
			DimCacheTester dCTest = new DimCacheTester();
			OlapStatement statement = dCTest.oc.createStatement();
			CellSet cellSet =
			    statement.executeOlapQuery(
			        "SELECT [Measures].[Value] ON COLUMNS,\n {[D1].Members} on 1\n"
			        		        + "FROM [testCube]");
			System.out.println("1. Before Flushing:");
			System.out.println("\t Mdx Query"+"SELECT [Measures].[Value] ON COLUMNS,\n {[D1].Members} on 1\n"
			        		        + "FROM [testCube]");
//			TraditionalCellSetFormatter rSt = new TraditionalCellSetFormatter();
			RectangularCellSetFormatter rSt = new RectangularCellSetFormatter(true);
			PrintWriter ps = new PrintWriter(System.out,true);
			
			rSt.format(cellSet, ps);
			cellSet =
			    statement.executeOlapQuery(
			        "SELECT [Measures].[Value] ON COLUMNS,\n {[D1].Members} on 1\n"
			        		        + "FROM [testCube]");
//			TraditionalCellSetFormatter rSt = new TraditionalCellSetFormatter();
			rSt = new RectangularCellSetFormatter(true);
			rSt.format(cellSet, ps);
			
			RolapSchema mondrianSchema = (RolapSchema)dCTest.mondrianConnection.getSchema();
			RolapCube testCube = (RolapCube)mondrianSchema.lookupCube("testCube", false);

			SchemaReader schemaReader =
				testCube.getSchemaReader(null);
			Member memberD1All =
			    schemaReader.getMemberByUniqueName(
			        Id.Segment.toList("D1", "All D1s"),
			        true);
			CacheControl cacheControl =
			    dCTest.mondrianConnection.getCacheControl(null);
			
			CacheControl.CellRegion measuresRegion =
			    cacheControl.createMeasuresRegion(
			    		testCube);
			
			CacheControl.CellRegion D1Region =
			    cacheControl.createMemberRegion(
			    		memberD1All, true);
			
			CacheControl.CellRegion regionOregonQ2 =
			    cacheControl.createCrossjoinRegion(
			        measuresRegion,
			        D1Region);
			String sql = "update TEST_FACT set FACT_VAL=4500 where DIM_1=2";
			java.sql.Statement stmt = dCTest.sqlConnection.createStatement();
			stmt.execute(sql);
			dCTest.sqlConnection.commit();
			
			System.out.println("Inserted a row in TEST_DIM_1:sql:"+"insert into TEST_DIM_1 values(4,'D1_4')");
			sql = "insert into TEST_DIM_1 values(4,'D1_4')";
			stmt = dCTest.sqlConnection.createStatement();
			stmt.execute(sql);
			dCTest.sqlConnection.commit();
			System.out.println("Inserted a row in TEST_FACT sql:" + "insert into TEST_FACT values(4,3,3,900)");
			sql = "insert into TEST_FACT values(4,3,3,900)";
			stmt = dCTest.sqlConnection.createStatement();
			stmt.execute(sql);			
			dCTest.sqlConnection.commit();
			System.out.println("Commited the changed to DB");
			try {
				cacheControl.flush(measuresRegion);
//				cacheControl.flush(regionOregonQ2);
////				cacheControl.flushSchema(mondrianSchema);
			} catch (Exception e) {
				sql = "delete TEST_DIM_1 where dim_1=4";
				stmt = dCTest.sqlConnection.createStatement();
				stmt.execute(sql);
				dCTest.sqlConnection.commit();
				throw e;
			}
			
			System.out.println("2. After Flushing:");
			System.out.println("\t Mdx Query"+"SELECT [Measures].[Value] ON COLUMNS,\n {[D1].Members} on 1\n"
			        		        + "FROM [testCube]");
			cellSet =
				statement.executeOlapQuery(
				        "SELECT [Measures].[Value] ON COLUMNS,\n {[D1].Members} on 1\n"
				        		        + "FROM [testCube]");
//			TraditionalCellSetFormatter rSt = new TraditionalCellSetFormatter();
			rSt = new RectangularCellSetFormatter(true);
			rSt.format(cellSet, ps);
			
			System.out.println("3. After Flushing:");
			System.out.println("\t Mdx Query"+"SELECT  {[D1].[D1_4]} on 0\n"
    		        + "FROM [testCube]");
			cellSet =
			    statement.executeOlapQuery(
			        "SELECT  {[D1].[D1_4]} on 0\n"
			        		        + "FROM [testCube]");
//			TraditionalCellSetFormatter rSt = new TraditionalCellSetFormatter();
			rSt = new RectangularCellSetFormatter(true);
			rSt.format(cellSet, ps);
			
			sql = "delete TEST_DIM_1 where dim_1=4";
			stmt = dCTest.sqlConnection.createStatement();
			stmt.execute(sql);
			sql = "delete test_Fact where dim_1=4";
			stmt = dCTest.sqlConnection.createStatement();
			stmt.execute(sql);
			dCTest.sqlConnection.commit();
			dCTest.sqlConnection.close();
			
			
			
		} catch (OlapException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
